## 收款啦
收款啦，是一款支付宝、微信、QQ收款码三合一整合系统。

采用 thinkPHP5.0 + MySQL + layui  完成

## 前言
不论是教程还是现成的代码，在网上几乎是遍地都是，为什么我还要自己写一套呢？

就是一个体现`套`字，包含上传二维码，识别二维码，生成三合一收款码，一整套流程服务。

绝大多数的三合一仅仅只是针对个人使用，而收款啦能对多用户提供三合一服务。

但是它却没有后台，原因主要有两个：

  1. 没有必频繁查看或修改配置，一次配置，终身使用。
  
  2. 作者懒癌发作（也促使没有安装向导）
  
  0. 如果实在需要的话，后面再说
  
本身代码是比较轻量级的，由于使用了框架导致体积增大。

好吧，本身也没啥技术含量，自己也几乎用不到，写给有需要的人类吧，顺便水水文~~逃(-




## 原理
收款码三合一，听上去感觉很神奇，其实原理非常简单！

所谓二维码，其实就是包含了一系列字符串的图片罢了。无论是支付宝还是微信的收款码，其本质上是一个包含了收款链接的二维码。所以我们的思路是：检测如果是支付宝浏览页面，就给出支付宝的付款链接、如果是微信，就给出微信链接……

然后这里涉及到一个知识点，`User-Agent`,大厂的webview都会携带自家的UA信息，比如说：

QQ：`MQQBrowser/6.2 TBS/043221 Safari/537.36 QQ/7.0.0.3135`

微信：`MQQBrowser/6.2 TBS 043220 Safari/537.36 MicroMessenger/6.5.8.1060 NetType/4G Language/zh_CN`

支付宝：`UCBrowser/11.5.0.939 UCBS/2.10.1.6 Mobile Safari/537.36 AliApp(AP/10.0.15.051805) AlipayClient/10.0.15.051805 Language/zh-Hans`

这样就很轻松区分是QQ还是微信还是支付宝扫码了：

`User-Agent` 含有 QQ/ 为QQ

`User-Agent` 含有 MicroMessenger 为微信

`User-Agent` 含有 AlipayClient 为支付宝

既然能够区分每个软件，那就可以通过自建一个网址，通过二维码生成扫描这个网址后，判断浏览器的UA，来分发不同的收款码

大致的流程则为：

客户端扫码 -> 服务端根据 `User-Agent` 判断客户端类型 -> 分别返回不同的处理

另外值得注意的是：

QQ：https 协议，无法唤醒QQ

支付宝：https 协议，可直接唤醒支付宝 APP

微信：微信自己的支付协议，无法唤醒微信

## 安装
0. PHP >= 5.6  + MySQL

1. 将应用程序部署到你的服务器中

2. 将`public`子目录设置为对外公开目录

3. 将根目录`pay.sql`导入你的数据库中

4. 修改`application\database.php`为自己数据库信息

5. 设置网站伪静态为`thinkPHP`

6. 修改根目录中`config.php`中的相关信息

7. 输入你的域名进行访问

需要在外网中才有效！需要在外网中才有效！需要在外网中才有效！重要的事情说三遍（里面局域网应该也有效，但那还有啥意义）


## Author

© [阿珏](https://github.com/178146582), Released under the [GPL](./LICENSE) License.<br>
如果可以的话，请打赏作者一份
![mahua](public/static/images/dashang.png)
> [Blog](https://www.52ecy.cn) · GitHub [@阿珏](https://github.com/178146582)
